import abc
from pyocs.pyocs_interface import UniteInterface


class V56Common(UniteInterface):

    def get_board_macro(self):
        # 主板宏：CVT_DEF_BOARD_TYPE
        product_split_list = self.request_dict[self.ocs_demand.product_name].split('.')
        main_project = product_split_list[1].rstrip('S')
        board_type = product_split_list[2]
        sub_board_split_list = self.request_dict[self.ocs_demand.port_name].split('_')
        sub_board_type = sub_board_split_list[1]
        board_macro = "ID_BD_VST56" + "_" + board_type + "_SUB_CH_" + sub_board_type
        ret = "#define CVT_DEF_BOARD_TYPE".ljust(self._space) + board_macro + '\n'
        return ret

    def get_chip_macro(self):
        # 主芯片宏：CVT_DEF_CHIPSET
        chip_type = self.request_dict[self.ocs_demand.chip_name]
        if 'TSUMV56RUU-Z1' in chip_type:
            ret = "#define CVT_DEF_CHIPSET".ljust(self._space) + 'CVT_TSUMV56RUU_Z1' + '\n'
        elif 'TSUMV56RUU(DD)' in chip_type:
            ret = "#define CVT_DEF_CHIPSET".ljust(self._space) + 'CVT_TSUMV56RUU' + '\n'
        else:
            raise RuntimeError('此芯片型号没有录入，请补充')
        return ret

    def get_pwm_macro(self):
        # Pwm占空比宏：[占空比：60]
        pwm_macro = self.request_dict[self.ocs_demand.pwm_name]
        ret = "#define CVT_DEF_CURRENT_REF_DUTY".ljust(self._space) + pwm_macro + '\n'
        return ret

    def get_code_branch(self):
        return self._code_branch

    @abc.abstractmethod
    def get_ocs_modelid(self):
        pass

    @abc.abstractmethod
    def get_ocs_require(self):
        pass

